----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 06/18/2020 02:40:31 PM
-- Design Name: 
-- Module Name: FSM_LAB - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity FSM_LAB is
port (
	clk, reset 	: in STD_LOGIC;
	start, sel	: in STD_LOGIC;
	led			: out STD_LOGIC
);
end FSM_LAB;

architecture Behavioral of FSM_LAB is

type state_type is (idle, sels, off2s, on2s, off4s, on4s);
signal cur_state, next_state : state_type;
signal count2s : unsigned(3 downto 0);
signal count4s : unsigned(4 downto 0);

signal c2s_ce, c2s_exp : std_logic;
signal c4s_ce, c4s_exp : std_logic;

begin


counter2s: process(clk)
begin
  if reset = '1' then
    count2s <= (others => '0');
  elsif clk'event and clk = '1' then
    if c2s_ce = '1' then
      if count2s = 15 then
         count2s <= (others => '0');
      else
         count2s <= count2s + 1;
      end if;
    end if;
  end if;
 
end process;

c2s_exp <= '1' when count2s = 15 else '0';

counter4s: process(clk)
begin
  if reset = '1' then
    count4s <= (others => '0');
  elsif clk'event and clk = '1' then
    if c4s_ce = '1' then
      if count4s = 31 then
         count4s <= (others => '0');
      else
         count4s <= count4s + 1;
      end if;
    end if;
  end if;
 
end process;

c4s_exp <= '1' when count4s = 31 else '0';
 
p1: process(reset, clk)
begin
  if reset = '1' then
    cur_state <= idle;
  elsif clk'event and clk = '1' then
    cur_state <= next_state;
  end if;
end process;

p2: process(cur_state, start, sel, c2s_exp, c4s_exp)
begin
  
  next_state <= cur_state;
  
  case cur_state is
  
    when idle =>
        if start = '1' then
            next_state <= sels;
        end if;
        
    when sels =>
        if sel = '0' then
            next_state <= off2s;
        else
            next_state <= off4s;
        end if;
    
    when off2s =>
        if c2s_exp = '1' then
             next_state <= on2s;
        end if;

    when on2s =>
        if c2s_exp = '1' then
             next_state <= sels;
        end if;
        
    when off4s =>
        if c4s_exp = '1' then
             next_state <= on4s;
        end if;
    
    when on4s =>
        if c4s_exp = '1' then
             next_state <= sels;
        end if;
        
    when others =>
        next_state <= idle;
        
  end case;
       
end process;

p3: process(cur_state)
begin
 
 led <= '0';
 c2s_ce <= '0';
 c4s_ce <= '0';
    
 case cur_state is
 
    when idle =>
    
    when sels =>
        
    
    when off2s =>
        c2s_ce <= '1';
    
    when on2s =>
        c2s_ce <= '1';
        led <= '1';
        
    when off4s =>
        c4s_ce <= '1';
        
    when on4s =>
        c4s_ce <= '1';
        led <= '1';
      
    when others =>
        led <= '0';
        c2s_ce <= '0';
        c4s_ce <= '0';
          
 end case;
 
end process;

end Behavioral;
